#!/usr/bin/env python
# setup.py generated by flit for tools that don't yet use PEP 517

from distutils.core import setup

packages = \
['lenskit',
 'lenskit.algorithms',
 'lenskit.algorithms.tf',
 'lenskit.batch',
 'lenskit.data',
 'lenskit.math',
 'lenskit.metrics',
 'lenskit.sharing',
 'lenskit.util']

package_data = \
{'': ['*']}

install_requires = \
['pandas >= 0.24',
 'numpy >= 1.17',
 'scipy >= 1.2',
 'numba >= 0.51, < 0.54',
 'pyarrow >= 0.15',
 'cffi >= 1.12.2',
 'psutil >= 5',
 'binpickle >= 0.3.2',
 'seedbank >= 0.1.0',
 'csr >= 0.3.1']

extras_require = \
{'demo': ['notebook >= 6', 'nbval >= 0.9', 'matplotlib ~= 3.4'],
 'dev': ['flit >= 3',
         'packaging >= 20',
         'flake8 >= 3',
         'coverage >= 5',
         'pytest-cov >= 2.12',
         'ipython >= 7',
         'docopt >= 0.6',
         'tqdm >= 4',
         'sphinx-autobuild >= 2021'],
 'doc': ['sphinx >= 3', 'sphinx_rtd_theme >= 0.5', 'nbsphinx >= 0.8'],
 'hpf': ['hpfrec'],
 'implicit': ['implicit'],
 'sklearn': ['scikit-learn >= 0.22'],
 'test': ['pytest >= 6', 'pytest-doctestplus >= 0.9', 'hypothesis >= 6'],
 'tf': ['tensorflow >= 2.1']}

setup(name='lenskit',
      version='0.13.1',
      description='The LensKit package.',
      author='Michael Ekstrand',
      author_email='michaelekstrand@boisestate.edu',
      url='https://lenskit.lenskit.org',
      packages=packages,
      package_data=package_data,
      install_requires=install_requires,
      extras_require=extras_require,
      python_requires='>= 3.7',
     )
